//=============================================================================
// MOBILE CORE
// 
//=============================================================================

var Imported = Imported || {};
Imported.MobileCore = true;

var MC = MC || {};
//=============================================================================
 /*:
 * @plugindesc ROGUELITE 2 Mobile core. DISABLE IF DEPLOYING TO MOBILE
 
//=============================================================================

*/
(function() {

	 TouchInput.keyRepeatWait = 3;
TouchInput.keyRepeatInterval = 2;

//SET BOSS COLLAPSE EFFECT TO MATCH NORMAL COLLAPSE

Sprite_Enemy.prototype.updateBossCollapse = function() {
    this.blendMode = Graphics.BLEND_ADD;
    this.setBlendColor([255, 128, 128, 128]);
    this.opacity *= this._effectDuration / (this._effectDuration + 1);
};

Sprite_Enemy.prototype.startBossCollapse = function() {
    this._effectDuration = 32;
    this._appeared = false;
};

Sprite_Enemy.prototype.updateFrame = function() {
    Sprite_Battler.prototype.updateFrame.call(this);
    var frameHeight = this.bitmap.height;
    this.setFrame(0, 0, this.bitmap.width, frameHeight);
};

//DISABLE TOUCH CONTROLS

Scene_Map.prototype.processMapTouch = function() {
    if (TouchInput.isTriggered() || this._touchCount > 0) {
        if (TouchInput.isPressed()) {
            if (this._touchCount === 0 || this._touchCount >= 15) {
                //var x = $gameMap.canvasToMapX(TouchInput.x);
                //var y = $gameMap.canvasToMapY(TouchInput.y);
                //$gameTemp.setDestination(x, y);
            }
            this._touchCount++;
        } else {
            this._touchCount = 0;
        }
    }
};

    //SHOW MOBILE UI DURING CHOICES

    Window_ChoiceList.prototype.start = function() {
    this.updatePlacement();
    this.updateBackground();
    SceneManager._scene.showVirtualButtons();
    ALOE.clearDpadInput();
    this.refresh();
    this.selectDefault();
    this.open();
    this.activate();
};

Scene_Map.prototype.isMenuCalled = function() {
    return Input.isTriggered('menu');
};

//DISABLE TOUCH CONTROLS IN BATTLE STATUS WINDOW

Window_BattleStatus.prototype.processTouch = function() {
    if (this.isOpenAndActive()) {
        if (TouchInput.isTriggered() && this.isTouchedInsideFrame()) {
            //this._touching = true;
            //this.onTouch(true);
        } else if (TouchInput.isCancelled()) {
            if (this.isCancelEnabled()) {
                this.processCancel();
            }
        }
        if (this._touching) {
            if (TouchInput.isPressed()) {
                this.onTouch(false);
            } else {
                this._touching = false;
            }
        }
    } else {
        this._touching = false;
    }
};

Window_BattleStatus.prototype.onTouch = function(triggered) {
    var lastIndex = this.index();
    var x = this.canvasToLocalX(TouchInput.x);
    var y = this.canvasToLocalY(TouchInput.y);
    var hitIndex = this.hitTest(x, y);
    if (hitIndex >= 0) {
        if (hitIndex === this.index()) {
            if (triggered && this.isTouchOkEnabled()) {
                //this.processOk();
            }
        } else if (this.isCursorMovable()) {
            //this.select(hitIndex);
        }
    } else if (this._stayCount >= 10) {
        if (y < this.padding) {
            //this.cursorUp();
        } else if (y >= this.height - this.padding) {
            //this.cursorDown();
        }
    }
    if (this.index() !== lastIndex) {
        //SoundManager.playCursor();
    }
};

Window_BattleStatus.prototype.hitTest = function(x, y) {
    return -1;
};

//REMOVE CERTAIN BATTLE ANIMATIONS

Sprite_Enemy.prototype.startWhiten = function() {
    this._effectDuration = 8;
};

Sprite_Enemy.prototype.startAppear = function() {
    this._effectDuration = 8;
    this._appeared = true;
};

Sprite_Enemy.prototype.startDisappear = function() {
    this._effectDuration = 16;
    this._appeared = false;
};

Sprite_Enemy.prototype.updateWhiten = function() {
    //var alpha = 128 - (16 - this._effectDuration) * 10;
    //this.setBlendColor([255, 255, 255, alpha]);
};

Sprite_Animation.prototype.updateFlash = function() {
    //if (this._flashDuration > 0) {
        //var d = this._flashDuration--;
        //this._flashColor[3] *= (d - 1) / d;
        //this._target.setBlendColor(this._flashColor);
    //}
};

//REMOVE SHOP MENU BUTTONS

Window_ShopNumber.prototype.updateButtonsVisiblity = function() {
        this.hideButtons();
};

//DISABLE TOUCH CONTROLS IN SHOP

Window_ShopStatus.prototype.isTouchedInsideFrame = function() {
    var x = this.canvasToLocalX(TouchInput.x);
    var y = this.canvasToLocalY(TouchInput.y);
    //return x >= 0 && y >= 0 && x < this.width && y < this.height;
};

 Scene_GameEnd.prototype.commandToTitle = function() {
    this.fadeOutAll();
    SceneManager.exit();
};



})();