//=============================================================================
// Blackmorning Engine Plugins - Shop Core
// BM_ShopCore.js
//=============================================================================

var Imported = Imported || {};
Imported.GBCore = true;

var GB = GB || {};
//=============================================================================
 /*:
 * @plugindesc Core code modifications for ROGUELITE 2

 * @requiredAssets img/pictures/FA_Archmage_5
 * @requiredAssets img/pictures/FA_Cleric_1
 * @requiredAssets img/pictures/FA_DarkKnight_1
 * @requiredAssets img/pictures/FA_Dragon_1
 * @requiredAssets img/pictures/FA_Druid_1
 * @requiredAssets img/pictures/FA_Gwen_1
 * @requiredAssets img/pictures/FA_Hero_1
 * @requiredAssets img/pictures/FA_Malady_1
 * @requiredAssets img/pictures/FA_Monk_5
 * @requiredAssets img/pictures/FA_Pirate_1
 * @requiredAssets img/pictures/FA_Prophet_1
 * @requiredAssets img/pictures/FA_Ranger_1
 * @requiredAssets img/pictures/FA_Rogue_1
 * @requiredAssets img/pictures/FA_Ruth_1
 * @requiredAssets img/pictures/FA_Villager_7
 * @requiredAssets img/pictures/FA_Warrior_1
 * @requiredAssets img/pictures/FA_Witch_5
 * @requiredAssets img/pictures/FA_Wizard_1

 */

//=============================================================================


(function() {

//SMALLER BATTLE MENU IN MOBILE

var $BATTLEWINPOSITION = 148;
var $ACTORPARTYWIDTH = 140;

Window_PartyCommand.prototype.initialize = function() {
    var y = Graphics.boxHeight - this.windowHeight();
    Window_Command.prototype.initialize.call(this, $BATTLEWINPOSITION, y);
    this.openness = 0;
    this.deactivate();
};

Window_ActorCommand.prototype.initialize = function() {
    var y = Graphics.boxHeight - this.windowHeight();
    Window_Command.prototype.initialize.call(this, $BATTLEWINPOSITION, y);
    this.openness = 0;
    this.deactivate();
    this._actor = null;
};

Scene_Battle.prototype.updateWindowPositions = function() {
    var statusX = 0;
    if (BattleManager.isInputting()) {
        statusX = this._partyCommandWindow.width + $BATTLEWINPOSITION;
    } else {
        statusX = this._partyCommandWindow.width / 2 + $BATTLEWINPOSITION;
    }
    if (this._statusWindow.x < statusX) {
        this._statusWindow.x += 16;
        if (this._statusWindow.x > statusX) {
            this._statusWindow.x = statusX;
        }
    }
    if (this._statusWindow.x > statusX) {
        this._statusWindow.x -= 16;
        if (this._statusWindow.x < statusX) {
            this._statusWindow.x = statusX;
        }
    }
};

Scene_Battle.prototype.adjustLowerWindow = function(win) {
    win.width = 700;
    win.height = win.fittingHeight(Yanfly.Param.BECWindowRows);
    win.y = Graphics.boxHeight - win.height;
    win.x = this._partyCommandWindow.width + $BATTLEWINPOSITION;
};

Window_BattleStatus.prototype.initialize = function() {
    var width = this.windowWidth();
    var height = this.windowHeight();
    var x = Graphics.boxWidth - width;
    var y = Graphics.boxHeight - height;
    Window_Selectable.prototype.initialize.call(this, x, y, width, height);
    this.refresh();
    this.openness = 0;
};

Window_BattleStatus.prototype.windowWidth = function() {
    return Graphics.boxWidth - 429;
};

//Modifications to Yanfly's Battle Status Window



//reduce party / actor window widths

Window_PartyCommand.prototype.windowWidth = function() {
    return $ACTORPARTYWIDTH;
};

Window_ActorCommand.prototype.windowWidth = function() {
    return $ACTORPARTYWIDTH;
}; 

//reduce party / actor window font size

Window_PartyCommand.prototype.standardFontSize = function() {
    return 28;
};

Window_ActorCommand.prototype.standardFontSize = function() {
    return 28;
};

//END BATTLE WINDOW SIZE   

//reduce font size of Help Window dialogue

Window_Help.prototype.standardFontSize = function() {
    return 28;
};

    var $MENUWIDTHS = 220;

//reduce selling price to 1/4 normal price

Scene_Shop.prototype.sellingPrice = function() {
    return Math.floor(this._item.price / 4);
};

//Remove flash effect from battle encounters

Scene_Map.prototype.updateEncounterEffect = function() {
    if (this._encounterEffectDuration > 0) {
        this._encounterEffectDuration--;
        var speed = this.encounterEffectSpeed();
        var n = speed - this._encounterEffectDuration;
        var p = n / speed;
        var q = ((p - 1) * 20 * p + 5) * p + 1;
        var zoomX = $gamePlayer.screenX();
        var zoomY = $gamePlayer.screenY() - 24;
        if (n === 2) {
            $gameScreen.setZoom(zoomX, zoomY, 1);
            this.snapForBattleBackground();
            //this.startFlashForEncounter(speed / 2);
        }
        $gameScreen.setZoom(zoomX, zoomY, q);
        if (n === Math.floor(speed / 6)) {
            //this.startFlashForEncounter(speed / 2);
        }
        if (n === Math.floor(speed / 2)) {
            BattleManager.playBattleBgm();
            this.startFadeOut(this.fadeSpeed());
        }
    }
};

//set battle encounter speed to 60

Scene_Map.prototype.encounterEffectSpeed = function() {
    return 60;
};

//Updates to SCENE_STATUS to show additional stats

/*

Window_Status.prototype.refresh = function() {
    this.contents.clear();
    if (this._actor) {
        var lineHeight = this.lineHeight();
        this.drawBlock1(lineHeight * 0);
        this.drawHorzLine(lineHeight * 1 + 9);
        this.drawBlock2(lineHeight * 2);
        this.drawHorzLine(lineHeight * 8);
        this.drawBlock3(lineHeight * 9);
    }
};

Window_Status.prototype.drawBlock1 = function(y) {
	var y2 = y + 10;
	this.drawActorFace(this._actor, 12, y - 4);
	this.drawActorLevel(this._actor, 244, y2);
    this.drawActorName(this._actor, 76, y2);
    this.drawActorClass(this._actor, 384, y2);
    this.drawActorNickname(this._actor, 432, y2);
};

Window_Status.prototype.drawBlock2 = function(y) {
    this.drawExpInfo(12, y);
    this.drawParameters(244, y);
};

Window_Status.prototype.drawBlock3 = function(y) {
    this.drawEquipments(12, y);
    this.drawEquipments2(432, y - 218);
};

Window_Status.prototype.drawEquipments = function(x, y) {
    var equips = this._actor.equips();
    var count = Math.min(equips.length, this.maxEquipmentLines());
    for (var i = 0; i < count; i++) {
        this.drawItemName(equips[i], x, y + this.lineHeight() * i);
    }
};

Window_Status.prototype.drawEquipments2 = function(x, y) {
    var equips = this._actor.equips();
    var count = Math.min(equips.length, 12);
    for (var i = 6; i < count; i++) {
        this.drawItemName(equips[i], x, y + this.lineHeight() * i);
    }
};

Window_Status.prototype.drawExpInfo = function(x, y) {
    var lineHeight = this.lineHeight();
    var expTotal = TextManager.expTotal.format(TextManager.exp);
    var expNext = TextManager.expNext.format(TextManager.level);
    var value1 = this._actor.currentExp();
    var value2 = this._actor.nextRequiredExp();
    if (this._actor.isMaxLevel()) {
        value1 = '-------';
        value2 = '-------';
    }
    this.changeTextColor(this.systemColor());
    this.drawText(expTotal, x, y + lineHeight * 0, 270);
    this.drawText(expNext, x, y + lineHeight * 2, 270);
    this.resetTextColor();
    this.drawText(value1, x - 90, y + lineHeight * 1, 270, 'right');
    this.drawText(value2, x - 90, y + lineHeight * 3, 270, 'right');

    var x2 = 502;
    var x3 = 200;
    var x4 = 220;
    this.changeTextColor(this.systemColor());
    this.drawText("Damage Reduction", x2, y, 180);
    this.drawText("Magic Reduction", x2, y + lineHeight, 180);
    this.drawText("Threat level", x2, y + lineHeight * 2, 180);
    this.drawText("Critical Rate", x2, y + lineHeight * 3, 180);


    this.resetTextColor();

    var threat = Math.floor(this._actor.sparam(0) * 100);
    var phys = Math.floor(100 - this._actor.sparam(6) * 100);
    var magi = Math.floor(100 - this._actor.sparam(7) * 100);
    var crit = Math.floor(this._actor.xparam(2) * 100);
    this.drawText((phys), x2 + x3, y, 60, 'right');
    this.drawText((magi), x2 + x3, y + lineHeight, 60, 'right');
    this.drawText((threat), x2 + x3, y + lineHeight * 2, 60, 'right');
    this.drawText((crit), x2 + x3, y + lineHeight * 3, 60, 'right');
    this.drawText("%", x2 + x4, y, 60, 'right');
    this.drawText("%", x2 + x4, y + lineHeight * 1, 60, 'right');
    this.drawText("%", x2 + x4, y + lineHeight * 2, 60, 'right');
    this.drawText("%", x2 + x4, y + lineHeight * 3, 60, 'right');
};

*/


//remove ME and BGS options from options menu

/*
Window_Options.prototype.addVolumeOptions = function() {
    this.addCommand(TextManager.bgmVolume, 'bgmVolume');
    this.addCommand(TextManager.seVolume, 'seVolume');
};
*/

//F1 is full-screen

Graphics._onKeyDown = function(event) {
    if (!event.ctrlKey && !event.altKey) {
        switch (event.keyCode) {
        case 113:   // F2
            event.preventDefault();
            this._switchFPSMeter();
            break;
        case 114:   // F3
            event.preventDefault();
            this._switchStretchMode();
            break;
        case 112:   // F1
            event.preventDefault();
            this._switchFullScreen();
            break;
        }
    }
};

//shop buttons are spaced closer together

Window_ShopNumber.prototype.placeButtons = function() {
    var numButtons = this._buttons.length;
    var spacing = 8;
    var totalWidth = -spacing;
    for (var i = 0; i < numButtons; i++) {
        totalWidth += this._buttons[i].width + spacing;
    }
    var x = (this.width - totalWidth) / 2;
    for (var j = 0; j < numButtons; j++) {
        var button = this._buttons[j];
        button.x = x;
        button.y = this.buttonY();
        x += button.width + spacing;
    }
};



//Fixes to BM_ShopCore

Window_ShopStatus.prototype.drawActorEquipInfo = function(x, y, actor) {
    var enabled = actor.canEquip(this._item);
    this.changePaintOpacity(enabled);
    this.resetTextColor();
	var item1 = this.currentEquippedItem(actor, this._item.etypeId);
	dw = (this._columnSize)/2
	this.drawActorCharacter(actor, x + dw + 16, y + 20)
	//this.drawIcon((item1 ? item1.iconIndex : 0), x + dw, y + 102)
    if (enabled) {
		this.setTempActor(actor, item1);
		this.contents.fontSize = BM.Shop.ParamFontSize
		var param = BM.Shop.SActorParam
		for (var i = 0; i < this._plist; i++) {
			dy = this._newPY +  this.textLineHeight()*i
			this.drawActorParamChange(x, dy, actor, item1, param[i]);
			this.contents.fontSize = BM.Shop.ParamFontSize
		}
    }
	this.resetFontSettings();
    this.changePaintOpacity(true);
};

//ROGUELITE SPECIFIC MODIFICATIONS

//Exit on menu now saves and exits game

Scene_GameEnd.prototype.commandToTitle = function() {
    $gameSystem.onBeforeSave();
    DataManager.saveGame(1);
    this.fadeOutAll();
    SceneManager.exit();
};

//GAME OVER
//If party is wiped, game will transfer player to the Hub instead of game over scene

Scene_Base.prototype.checkGameover = function() {
    if ($gameParty.isAllDead()) {
        SceneManager.pop();
        $gameTemp.reserveCommonEvent(47);
    }
};

BattleManager.updateBattleEnd = function() {
    if (this.isBattleTest()) {
        AudioManager.stopBgm();
        SceneManager.exit();
    } else if (!this._escaped && $gameParty.isAllDead()) {
        if (this._canLose) {
            $gameParty.reviveBattleMembers();
            SceneManager.pop();
        } else {
            $gameParty.reviveBattleMembers();
            SceneManager.pop();
            $gameTemp.reserveCommonEvent(47);
        }
    } else {
        SceneManager.pop();
    }
    this._phase = null;
};



Scene_Menu.prototype.createGoldWindow = function() {
    this._goldWindow = new Window_Gold(0, 0);
    this._goldWindow.y = Graphics.boxHeight - this._goldWindow.height;
    this.addWindow(this._goldWindow);
}

Scene_Menu.prototype.createStatusWindow = function() {
    this._statusWindow = new Window_MenuStatus($MENUWIDTHS, 0);
    this._statusWindow.reserveFaceImages();
    this.addWindow(this._statusWindow);
};

Window_MenuStatus.prototype.windowWidth = function() {
    return Graphics.boxWidth - $MENUWIDTHS;
};

//window class for showing current time

Game_System.prototype.playmenuText = function() {
    var hour = Math.floor(this.playtime() / 60 / 60);
    var min = Math.floor(this.playtime() / 60) % 60;
    return hour.padZero(2) + ':' + min.padZero(2);
};

function Window_Time() {
    this.initialize.apply(this, arguments);
};

Window_Time.prototype = Object.create(Window_Base.prototype);
Window_Time.prototype.constructor = Window_Time;

Window_Time.prototype.initialize = function(x, y) {
    var width = this.windowWidth();
    var height = this.windowHeight();
    Window_Base.prototype.initialize.call(this, x, y, width, height);
    this.refresh();
};

Window_Time.prototype.windowWidth = function() {
    return $MENUWIDTHS;
};

Window_Time.prototype.windowHeight = function() {
    return this.fittingHeight(1);
};

Window_Time.prototype.refresh = function() {
    var x = this.textPadding();
    var width = this.contents.width - this.textPadding() * 2;
    this.contents.clear();
    this.drawText("Time:", x, 0, width, 'left');
    this.drawText($gameSystem.playmenuText(), x, 0, width, 'right');
};

Window_Time.prototype.open = function() {
    this.refresh();
    Window_Base.prototype.open.call(this);
};

//window class for showing current location

function Window_Location() {
    this.initialize.apply(this, arguments);
}

Window_Location.prototype = Object.create(Window_Base.prototype);
Window_Location.prototype.constructor = Window_Location;

Window_Location.prototype.initialize = function(x, y) {
    var width = this.windowWidth();
    var height = this.windowHeight();
    Window_Base.prototype.initialize.call(this, x, y, width, height);
    this.refresh();
};

Window_Location.prototype.windowWidth = function() {
    return $MENUWIDTHS;
};

Window_Location.prototype.windowHeight = function() {
    return this.fittingHeight(1);
};

Window_Location.prototype.refresh = function() {
    var x = this.textPadding();
    var width = this.contents.width - this.textPadding() * 2;
    this.contents.clear();
    var displayName = $dataMap.displayName;
    var floorNumber = $gameVariables.value(1);
    if ($gameSwitches.value(51) === true) {
            this.drawText("Floor " + floorNumber, x, 0, width, 'center'); }
        else { 
            this.drawText(displayName, x, 0, width, 'center');
        }
    
    
};

Window_Location.prototype.open = function() {
    this.refresh();
    Window_Base.prototype.open.call(this);
};

//scene_menu changed to add Time and Location windows

Scene_Menu.prototype.create = function() {
    Scene_MenuBase.prototype.create.call(this);
    this.createCommandWindow();
    this.createGoldWindow();
    this.createLocationWindow();
    this.createTimeWindow();
    this.createStatusWindow();
};

Scene_Menu.prototype.createTimeWindow = function() {
    this._timeWindow = new Window_Time(0, 0);
    this._timeWindow.y = Graphics.boxHeight - this._goldWindow.height * 2;
    this.addWindow(this._timeWindow);
};

Scene_Menu.prototype.createLocationWindow = function() {
    this._locationWindow = new Window_Location(0, 0);
    this._locationWindow.y = Graphics.boxHeight - this._goldWindow.height * 3;
    this.addWindow(this._locationWindow);
};

Window_Gold.prototype.windowWidth = function() {
    return $MENUWIDTHS;
};

Window_MenuCommand.prototype.windowWidth = function() {
    return $MENUWIDTHS;
};

Scene_Menu.prototype.createCommandWindow = function() {
    this._commandWindow = new Window_MenuCommand(0, 0);
    this.createCommandWindowBinds();
    this._commandWindow.setHandler('cancel',    this.popScene.bind(this));
    this.addWindow(this._commandWindow);
};

//OLIVIA WEAKNESS DISPLAY ICON FIX

Window_WeaknessDisplay.prototype.setCalculationConstants = function() {
    this._factorX = -1 * Math.ceil(Graphics.boxWidth * 0.25);
    this._factorY = -1 * Math.round(this.lineHeight() * 1);
};

Window_WeaknessDisplay.prototype.drawSmallIcon = function(iconIndex, x, y) {
    var bitmap = ImageManager.loadSystem('IconSet');
    var pw = Window_Base._iconWidth;
    var ph = Window_Base._iconHeight;
    var sx = iconIndex % 16 * pw;
    var sy = Math.floor(iconIndex / 16) * ph;
    var rate = Olivia.OctoBattle.WeaknessDisplay.WeakIconSize;
    this.contents.blt(bitmap, sx, sy, pw, ph, x, y - 38, Math.round(pw * rate), Math.round(ph * rate));
};

Window_WeaknessDisplay.prototype.drawSubjectName = function() {
    if (Olivia.OctoBattle.WeaknessDisplay.ShowName) {
        this.resetFontSettings();
        this.contents.fontSize = Olivia.OctoBattle.WeaknessDisplay.NameFontSize;
        if (this._subject.hpRate() > 0.50) {
            this.changeTextColor(this.normalColor());
        } else if (this._subject.hpRate() > 0.25) {
            this.changeTextColor(this.textColor(Olivia.OctoBattle.WeaknessDisplay.HpColor50));
        } else {
            this.changeTextColor(this.textColor(Olivia.OctoBattle.WeaknessDisplay.HpColor25));
        }
        this.drawText(this._subject.name(), 0, 6, this.contentsWidth(), 'center');
        this.resetFontSettings();
    }
};

//MODIFY EXP CURVE TO DOUBLE "EXTRA VALUE"

Game_Actor.prototype.expForLevel = function(level) {
    var c = this.currentClass();
    var basis = c.expParams[0];
    var extra = c.expParams[1];
    var acc_a = c.expParams[2];
    var acc_b = c.expParams[3];
    return Math.round(basis*(Math.pow(level-1, 0.9+acc_a/250))*level*
            (level+1)/(6+Math.pow(level,2)/50/acc_b)+(level-1)*(extra*4));
};

//YANFLY SET OUTLINE COLOR

Window_Base.prototype.resetFontSettings = function() {
    Yanfly.Message.Window_Base_resetFontSettings.call(this);
    this.contents.fontBold = false;
    this.contents.fontItalic = false;
    this.contents.outlineColor = 'rgba(50, 50, 50, 0.6)';
    this.contents.outlineWidth = $gameSystem.getMessageFontOutline();
};

})();